function sendToDVR(commandValue) {
	var ajaxObject = new XMLHttpRequest();
	ajaxObject.onreadystatechange = readResponse;
	ajaxObject.open( "GET", commandValue, true );
	ajaxObject.send();
}

function readResponse() {
	if (this.readyState == 4) {
			var dvrResponse=eval('('+this.responseText+')');
			if ((dvrResponse.status.msg != "OK" ) && (dvrResponse.status.msg != "OK.")) {
			    alert('Error: '+dvrResponse.status.code+' Message: '+dvrResponse.status.msg+'  Query: '+dvrResponse.status.query);
			}
	}
}

function mouseClicked(x,y) {
	var buttonClicked="";
	var buttonName="";
	for (i=0; i < remoteObject.imageAreas.length; i++) {
		var leftX=remoteObject.imageAreas[i].leftX;
		var rightX=remoteObject.imageAreas[i].rightX;
		var topY=remoteObject.imageAreas[i].topY;
		var bottomY=remoteObject.imageAreas[i].bottomY;
		var keyName=remoteObject.imageAreas[i].keyName;
		var speechName=remoteObject.imageAreas[i].speechName;
		if ((x >= leftX) && (x <= rightX) && (y >= topY) && (y <= bottomY)) {
			buttonClicked=keyName;
			buttonName=speechName;
			break;
		}
	}

	if (buttonClicked != "") {
		var command='http://'+preferences.currentDVRIP.value+':8080/remote/processKey?key='+buttonClicked;
		sendToDVR(command);
		if (preferences.speakKeyNames.value == 1) {
			speak(buttonName);
		}
	}
}
function displayCurrentTime() {
	currentTime=new Date();
	var mon=currentTime.getMonth()+1;
	var day=currentTime.getDate();
	var year=currentTime.getFullYear();
	var secs=currentTime.getSeconds();
	if (secs < 10) {
		secs="0"+secs;
	}
	if (mon < 10) {
		mon="0"+mon;
	}
	if (day < 10) {
		day="0"+day;
	}
	hours=currentTime.getHours();
	mins=currentTime.getMinutes();
	var amPM="am";
	if (hours > 11) {
		amPM="pm";
		if (hours > 12) {
			hours=hours - 12;
		}
	}
	if (hours == 0) {
		hours=12;
	}	
	if (hours < 10) {
		hours="0"+hours;
	}
	if (mins < 10) {
		mins="0"+mins;
	}
	dateTime.data=mon+"/"+day+"/"+year+" "+hours+":"+mins+":"+secs+" "+amPM;
}

function displayCurrentInfo() {
	var command='http://'+preferences.currentDVRIP.value+':8080/tv/getTuned';
	var ajaxObject = new XMLHttpRequest();
	ajaxObject.onreadystatechange = readTuned;
	ajaxObject.open( "GET", command, true );
	ajaxObject.send();
}

function readTuned() {
	if (this.readyState != 4) {
		return;
	}
	var dvrResponse=eval('('+this.responseText+')');
	var callSign=dvrResponse.callsign;
	var majorChannel=dvrResponse.major;
	var minorChannel=dvrResponse.minor;
	var channel=majorChannel
	var otaSat="";
	var playBack="";
	progInfo.style.color="white";
	var progRecording="";
	if (minorChannel < 65535) {
		channel+="-"+minorChannel;
	}
	if (dvrResponse.isOffAir) {
		otaSat=" (OTA)";
	}

	if (dvrResponse.isRecording) {
		progRecording=" \u00AE";
		progInfo.style.color="orange";
	}
	if ((dvrResponse.uniqueId != undefined) && (dvrResponse.uniqueId != "")) {
		playBack=" (Playback)"
	}
	var programTitle=dvrResponse.title;
	if ((dvrResponse.status.msg != "OK" ) && (dvrResponse.status.msg != "OK.") && (dvrResponse.status.code != 500)) {
	   	alert('Error: '+dvrResponse.status.code+' Message: '+dvrResponse.status.msg+'  Query: '+dvrResponse.status.query);
	} else {
		progInfo.data="";
		progInfo.data=callSign+" "+channel+otaSat+progRecording+playBack+" -- "+programTitle;
	}
	if ((currentProgramTitle != programTitle) && (currentProgramTitle != "")) {
		if (preferences.speakTitle.value == 1) {
			speak('Channel '+channel+'    now playing '+programTitle);
		}
	}
	currentProgramTitle=programTitle;
}

function runMacro(macroNumber) {
	var macroLabel="";

	mlid="macroLabel"+macroNumber;
	mvid="macroValue"+macroNumber;
	macroLabel=document.getElementById(mlid).value;
	macroList=document.getElementById(mvid).value.split(" ");

	for ( i=0; i < macroList.length; i++) {
		var command='http://'+preferences.currentDVRIP.value+':8080/remote/processKey?key='+macroList[i];
		sendToDVR(command);
		sleep(350);
	}
	if ((preferences.speakMacroText.value == "1") && (macroLabel != "")) {
		speak(macroLabel);
	}
}

function sleep(milliseconds) {
	var start = new Date().getTime();
	for (var i = 0; i < 1e7; i++) {
		if ((new Date().getTime() - start) > milliseconds){
			break;
		}
	}
}

function displayMacros() {

	var cellWidth="80";
	var i=0;
	for (i=1; i < 51; i++) {
		mid="m"+i;
		mlid="macroLabel"+i;
		midObj=document.getElementById(mid);
		mlidObj=document.getElementById(mlid);
		midObj.data=mlidObj.value;
		if (midObj.data == "") {
			midObj.width=0;
			midObj.style.backgroundColor="transparent";
		} else {
			midObj.width=cellWidth;
			midObj.style.backgroundColor=preferences.textBG.value;
			midObj.style.color=preferences.textFG.value;
			midObj.style.fontFamily="'Arial Narrow'";
		}
	}
}
function preferencesChanged() {

	dvrInfo.data="";
	progInfo.data="";
	var dvrIP="";
	var dvrName="";
	var curDVR=preferences.currentDVRNumber.value;
	dvrMenu.length=0;
	for (i=1; i < 9; i++) {
		dvrIP=document.getElementById("DVRIPAddress"+i).value;
		dvrName=document.getElementById("DVRName"+i).value;
		if ((dvrIP != "") && dvrName != "") {
				var j=i - 1;
				dvrMenu[j]=new MenuItem;
				dvrMenu[j].title=dvrName;
				dvrMenu[j].dvrNumberSelected=i;
				dvrMenu[j].onSelect=function() {preferences.currentDVRNumber.value=this.dvrNumberSelected; preferencesChanged();};
		}
	}
	for (k=0; k < dvrMenu.length; k++) {
		var l=k+1;
		if (l == preferences.currentDVRNumber.value) {
			dvrMenu[k].checked="true";
		} else {
			dvrMenu[k].checked="false";
		}
	}
	var dvrIPId="DVRIPAddress"+preferences.currentDVRNumber.value;
	var dvrNameId="DVRName"+preferences.currentDVRNumber.value;
	preferences.currentDVRIP.value=document.getElementById(dvrIPId).value;
	preferences.currentDVRName.value=document.getElementById(dvrNameId).value;
	dvrInfo.data="DVR: "+preferences.currentDVRName.value+" ("+preferences.currentDVRIP.value+")";

	displayCurrentTime();
	displayMacros();
	if (preferences.fullSizeRemote.value == 1) {
		vOffsetMultiplier=22;
		macroHeight=20;
		righthOffset=250;
		infoWidth=330;
		labelVOffset=607;
		selectDVR.vOffset=580;
		document.getElementById('remoteImage').src="Images/remote.png";
		remoteObject=fullSizeRemoteObject;
	} else {
		vOffsetMultiplier=15;
		macroHeight=13;
		righthOffset=190;
		infoWidth=265;
		labelVOffset=407;
		selectDVR.vOffset=392;
		document.getElementById('remoteImage').src="Images/small-remote.png";
		remoteObject=smallRemoteObject;
	}
	for (i=1; i < 51; i++) {
		objId='m'+i;
		document.getElementById(objId).height=macroHeight;
		if (i > 25) {
			j=i - 25;
		} else {
			j=i;
		}
		ypos=(j * vOffsetMultiplier);
		document.getElementById(objId).vOffset=ypos;
		if (i > 25) {
			document.getElementById(objId).hOffset=righthOffset;
		}
	}
	displayCurrentInfo();
	dateTime.vOffset=labelVOffset;
	dateTime.width=infoWidth;
	labelVOffset=labelVOffset+11;
	dvrInfo.vOffset=labelVOffset;
	dvrInfo.width=infoWidth;
	labelVOffset=labelVOffset+11;
	progInfo.vOffset=labelVOffset;
	progInfo.width=infoWidth;
	labelVOffset=labelVOffset+11;

	showPreferences();
}
function doPopup() {
	if (preferences.fullSizeRemote.value == 1) {
		popupMenu(dvrMenu,50,450);
	} else {
		popupMenu(dvrMenu,50,250);
	}
}

var currentProgramTitle="";
var programTitle="";
var vOffsetMultiplier=22;
var macroHeight=20;
var righthOffset=250;
	fullSizeRemoteObject={"imageAreas": [
		{"leftX": 70,  "rightX": 102, "topY": 52,  "bottomY": 68,  "keyName": "power",    "speechName": "power"},
		{"leftX": 25,  "rightX": 42,  "topY": 70,  "bottomY": 87,  "keyName": "format",   "speechName": "format"},
		{"leftX": 130, "rightX": 146, "topY": 69,  "bottomY": 86,  "keyName": "poweroff", "speechName": "power off"},
		{"leftX": 128, "rightX": 148, "topY": 43,  "bottomY": 62,  "keyName": "poweron",  "speechName": "power on"},
		{"leftX": 49,  "rightX": 70,  "topY": 152, "bottomY": 174, "keyName": "pause",    "speechName": "pause"},
		{"leftX": 28,  "rightX": 56,  "topY": 123, "bottomY": 143, "keyName": "rew",      "speechName": "rewind"},
		{"leftX": 46,  "rightX": 69,  "topY": 94,  "bottomY": 115, "keyName": "replay",   "speechName": "replay"},
		{"leftX": 77,  "rightX": 95,  "topY": 82,  "bottomY": 105, "keyName": "stop",     "speechName": "stop"},
		{"leftX": 103, "rightX": 125, "topY": 93,  "bottomY": 116, "keyName": "advance",  "speechName": "advance"},
		{"leftX": 118, "rightX": 145, "topY": 124, "bottomY": 142, "keyName": "ffwd",     "speechName": "fast forward"},
		{"leftX": 103, "rightX": 125, "topY": 152, "bottomY": 173, "keyName": "record",   "speechName": "ree cord"},
		{"leftX": 72,  "rightX": 103, "topY": 119, "bottomY": 150, "keyName": "play",     "speechName": "play"},
		{"leftX": 25,  "rightX": 51,  "topY": 194, "bottomY": 220, "keyName": "guide",    "speechName": "guide"},
		{"leftX": 56,  "rightX": 80,  "topY": 180, "bottomY": 201, "keyName": "active",   "speechName": "active"},
		{"leftX": 93,  "rightX": 117, "topY": 177, "bottomY": 201, "keyName": "list",     "speechName": "list"},
		{"leftX": 123, "rightX": 146, "topY": 194, "bottomY": 220, "keyName": "exit",     "speechName": "exit"},
		{"leftX": 65,  "rightX": 109, "topY": 206, "bottomY": 223, "keyName": "up",       "speechName": "up"},
		{"leftX": 69,  "rightX": 103, "topY": 272, "bottomY": 290, "keyName": "down",     "speechName": "down"},
		{"leftX": 41,  "rightX": 64,  "topY": 229, "bottomY": 266, "keyName": "left",     "speechName": "left"},
		{"leftX": 109, "rightX": 129, "topY": 228, "bottomY": 268, "keyName": "right",    "speechName": "right"},
		{"leftX": 71,  "rightX": 102, "topY": 232, "bottomY": 263, "keyName": "select",   "speechName": "select"},
		{"leftX": 28,  "rightX": 52,  "topY": 276, "bottomY": 301, "keyName": "back",     "speechName": "back"},
		{"leftX": 70,  "rightX": 102, "topY": 300, "bottomY": 316, "keyName": "menu",     "speechName": "menu"},
		{"leftX": 121, "rightX": 145, "topY": 277, "bottomY": 302, "keyName": "info",     "speechName": "info"},
		{"leftX": 38,  "rightX": 57,  "topY": 314, "bottomY": 333, "keyName": "red",      "speechName": "red"},
		{"leftX": 63,  "rightX": 81,  "topY": 330, "bottomY": 349, "keyName": "green",    "speechName": "green"},
		{"leftX": 93,  "rightX": 112, "topY": 330, "bottomY": 349, "keyName": "yellow",   "speechName": "yellow"},
		{"leftX": 117, "rightX": 136, "topY": 313, "bottomY": 332, "keyName": "blue",     "speechName": "blue"},
		{"leftX": 114, "rightX": 143, "topY": 351, "bottomY": 384, "keyName": "chanup",   "speechName": "channel up"},
		{"leftX": 114, "rightX": 140, "topY": 385, "bottomY": 417, "keyName": "chandown", "speechName": "channel down"},
		{"leftX": 115, "rightX": 137, "topY": 424, "bottomY": 446, "keyName": "prev",     "speechName": "previous channel"},
		{"leftX": 36,  "rightX": 64,  "topY": 457, "bottomY": 474, "keyName": "1",        "speechName": "1"},
		{"leftX": 74,  "rightX": 102, "topY": 457, "bottomY": 474, "keyName": "2",        "speechName": "2"},
		{"leftX": 112, "rightX": 141, "topY": 457, "bottomY": 474, "keyName": "3",        "speechName": "3"},
		{"leftX": 36,  "rightX": 64,  "topY": 485, "bottomY": 502, "keyName": "4",        "speechName": "4"},
		{"leftX": 74,  "rightX": 102, "topY": 485, "bottomY": 502, "keyName": "5",        "speechName": "5"},
		{"leftX": 112, "rightX": 141, "topY": 485, "bottomY": 502, "keyName": "6",        "speechName": "6"},
		{"leftX": 36,  "rightX": 64,  "topY": 513, "bottomY": 530, "keyName": "7",        "speechName": "7"},
		{"leftX": 74,  "rightX": 102, "topY": 513, "bottomY": 530, "keyName": "8",        "speechName": "8"},
		{"leftX": 112, "rightX": 141, "topY": 513, "bottomY": 530, "keyName": "9",        "speechName": "9"},
		{"leftX": 36,  "rightX": 64,  "topY": 540, "bottomY": 559, "keyName": "dash",     "speechName": "dash"},
		{"leftX": 74,  "rightX": 102, "topY": 540, "bottomY": 559, "keyName": "0",        "speechName": "0"},
		{"leftX": 112, "rightX": 141, "topY": 540, "bottomY": 559, "keyName": "enter",    "speechName": "enter"} 
		
	] };

	smallRemoteObject={"imageAreas": [
		{"leftX": 45,  "rightX": 68,  "topY": 35,  "bottomY": 45,  "keyName": "power",    "speechName": "power"},
		{"leftX": 17,  "rightX": 28,  "topY": 46,  "bottomY": 56,  "keyName": "format",   "speechName": "format"},
		{"leftX": 86,  "rightX": 99,  "topY": 45,  "bottomY": 57,  "keyName": "poweroff", "speechName": "power off"},
		{"leftX": 86,  "rightX": 100, "topY": 27,  "bottomY": 40,  "keyName": "poweron",  "speechName": "power on"},
		{"leftX": 30,  "rightX": 45,  "topY": 103, "bottomY": 112, "keyName": "pause",    "speechName": "pause"},
		{"leftX": 17,  "rightX": 36,  "topY": 81,  "bottomY": 96,  "keyName": "rew",      "speechName": "rewind"},
		{"leftX": 30,  "rightX": 48,  "topY": 62,  "bottomY": 73,  "keyName": "replay",   "speechName": "replay"},
		{"leftX": 50,  "rightX": 65,  "topY": 54,  "bottomY": 69,  "keyName": "stop",     "speechName": "stop"},
		{"leftX": 67,  "rightX": 81,  "topY": 61,  "bottomY": 74,  "keyName": "advance",  "speechName": "advance"},
		{"leftX": 78,  "rightX": 97,  "topY": 81,  "bottomY": 95,  "keyName": "ffwd",     "speechName": "fast forward"},
		{"leftX": 67,  "rightX": 83,  "topY": 100, "bottomY": 113, "keyName": "record",   "speechName": "ree cord"},
		{"leftX": 47,  "rightX": 68,  "topY": 77,  "bottomY": 96,  "keyName": "play",     "speechName": "play"},
		{"leftX": 16,  "rightX": 31,  "topY": 130, "bottomY": 144, "keyName": "guide",    "speechName": "guide"},
		{"leftX": 37,  "rightX": 54,  "topY": 119, "bottomY": 129, "keyName": "active",   "speechName": "active"},
		{"leftX": 63,  "rightX": 75,  "topY": 119, "bottomY": 129, "keyName": "list",     "speechName": "list"},
		{"leftX": 80,  "rightX": 96,  "topY": 129, "bottomY": 144, "keyName": "exit",     "speechName": "exit"},
		{"leftX": 39,  "rightX": 70,  "topY": 134, "bottomY": 149, "keyName": "up",       "speechName": "up"},
		{"leftX": 43,  "rightX": 76,  "topY": 179, "bottomY": 188, "keyName": "down",     "speechName": "down"},
		{"leftX": 29,  "rightX": 42,  "topY": 147, "bottomY": 176, "keyName": "left",     "speechName": "left"},
		{"leftX": 79,  "rightX": 82,  "topY": 149, "bottomY": 180, "keyName": "right",    "speechName": "right"},
		{"leftX": 48,  "rightX": 76,  "topY": 151, "bottomY": 173, "keyName": "select",   "speechName": "select"},
		{"leftX": 19,  "rightX": 34,  "topY": 183, "bottomY": 196, "keyName": "back",     "speechName": "back"},
		{"leftX": 46,  "rightX": 67,  "topY": 196, "bottomY": 208, "keyName": "menu",     "speechName": "menu"},
		{"leftX": 77,  "rightX": 94,  "topY": 186, "bottomY": 193, "keyName": "info",     "speechName": "info"},
		{"leftX": 24,  "rightX": 36,  "topY": 208, "bottomY": 220, "keyName": "red",      "speechName": "red"},
		{"leftX": 42,  "rightX": 54,  "topY": 219, "bottomY": 231, "keyName": "green",    "speechName": "green"},
		{"leftX": 60,  "rightX": 74,  "topY": 219, "bottomY": 231, "keyName": "yellow",   "speechName": "yellow"},
		{"leftX": 76,  "rightX": 91,  "topY": 208, "bottomY": 220, "keyName": "blue",     "speechName": "blue"},
		{"leftX": 74,  "rightX": 94,  "topY": 232, "bottomY": 257, "keyName": "chanup",   "speechName": "channel up"},
		{"leftX": 74,  "rightX": 94,  "topY": 257, "bottomY": 276, "keyName": "chandown", "speechName": "channel down"},
		{"leftX": 77,  "rightX": 92,  "topY": 281, "bottomY": 295, "keyName": "prev",     "speechName": "previous channel"},

		{"leftX": 23,  "rightX": 42,  "topY": 301, "bottomY": 314, "keyName": "1",        "speechName": "1"},
		{"leftX": 50,  "rightX": 66,  "topY": 301, "bottomY": 314, "keyName": "2",        "speechName": "2"},
		{"leftX": 74,  "rightX": 90,  "topY": 301, "bottomY": 314, "keyName": "3",        "speechName": "3"},

		{"leftX": 23,  "rightX": 42,  "topY": 320, "bottomY": 334, "keyName": "4",        "speechName": "4"},
		{"leftX": 50,  "rightX": 66,  "topY": 320, "bottomY": 334, "keyName": "5",        "speechName": "5"},
		{"leftX": 74,  "rightX": 90,  "topY": 320, "bottomY": 334, "keyName": "6",        "speechName": "6"},

		{"leftX": 23,  "rightX": 42,  "topY": 340, "bottomY": 350, "keyName": "7",        "speechName": "7"},
		{"leftX": 50,  "rightX": 66,  "topY": 340, "bottomY": 350, "keyName": "8",        "speechName": "8"},
		{"leftX": 74,  "rightX": 90,  "topY": 340, "bottomY": 350, "keyName": "9",        "speechName": "9"},

		{"leftX": 23,  "rightX": 42,  "topY": 358, "bottomY": 371, "keyName": "dash",     "speechName": "dash"},
		{"leftX": 50,  "rightX": 66,  "topY": 358, "bottomY": 371, "keyName": "0",        "speechName": "0"},
		{"leftX": 74,  "rightX": 90,  "topY": 358, "bottomY": 371, "keyName": "enter",    "speechName": "enter"} 
	] };

    var dvrMenu = new Array();
	var dvrIP="";
	var dvrName="";
	var curDVR=preferences.currentDVRNumber.value;
	for (i=1; i < 9; i++) {
		dvrIP=document.getElementById("DVRIPAddress"+i).value;
		dvrName=document.getElementById("DVRName"+i).value;
		if ((dvrIP != "") && dvrName != "") {
				var j=i - 1;
				dvrMenu[j]=new MenuItem;
				dvrMenu[j].title=dvrName;
				dvrMenu[j].dvrNumberSelected=i;
				dvrMenu[j].onSelect=function() {preferences.currentDVRNumber.value=this.dvrNumberSelected; preferencesChanged();};
		}
	}

	var fileName=system.userDocumentsFolder+"/DirecTVWidgetPreferences.txt";
	if (filesystem.itemExists(fileName)) {
			var preferenceFileData=filesystem.readFile(fileName);
			eval(preferenceFileData);
	}
	widget.onPreferencesChanged = function ( event ) { preferencesChanged(); };

	preferencesChanged();
	displayMacros();

function showPreferences() {
		preferenceString=new Array();
		i=0; preferenceString[i]='preferences.fullSizeRemote.value="'+preferences.fullSizeRemote.value+'"; ';
		i++; preferenceString[i]='preferences.speakMacroText.value="'+preferences.speakMacroText.value+'"; ';
		i++; preferenceString[i]='preferences.speakKeyNames.value="'+preferences.speakKeyNames.value+'"; ';
		i++; preferenceString[i]='preferences.speakTitle.value="'+preferences.speakTitle.value+'"; ';
		i++; preferenceString[i]='preferences.textBG.value="'+preferences.textBG.value+'"; ';
		i++; preferenceString[i]='preferences.textFG.value="'+preferences.textFG.value+'"; ';
		i++; preferenceString[i]='preferences.currentDVRIP.value="'+preferences.currentDVRIP.value+'"; ';
		i++; preferenceString[i]='preferences.currentDVRName.value="'+preferences.currentDVRName.value+'"; ';
		i++; preferenceString[i]='preferences.currentDVRNumber.value="'+preferences.currentDVRNumber.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress1.value="'+preferences.DVRIPAddress1.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName1.value="'+preferences.DVRName1.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress2.value="'+preferences.DVRIPAddress2.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName2.value="'+preferences.DVRName2.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress3.value="'+preferences.DVRIPAddress3.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName3.value="'+preferences.DVRName3.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress4.value="'+preferences.DVRIPAddress4.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName4.value="'+preferences.DVRName4.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress5.value="'+preferences.DVRIPAddress5.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName5.value="'+preferences.DVRName5.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress6.value="'+preferences.DVRIPAddress6.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName6.value="'+preferences.DVRName6.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress7.value="'+preferences.DVRIPAddress7.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName7.value="'+preferences.DVRName7.value+'"; ';
		i++; preferenceString[i]='preferences.DVRIPAddress8.value="'+preferences.DVRIPAddress8.value+'"; ';
		i++; preferenceString[i]='preferences.DVRName8.value="'+preferences.DVRName8.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel1.value="'+preferences.macroLabel1.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue1.value="'+preferences.macroValue1.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel2.value="'+preferences.macroLabel2.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue2.value="'+preferences.macroValue2.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel3.value="'+preferences.macroLabel3.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue3.value="'+preferences.macroValue3.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel4.value="'+preferences.macroLabel4.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue4.value="'+preferences.macroValue4.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel5.value="'+preferences.macroLabel5.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue5.value="'+preferences.macroValue5.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel6.value="'+preferences.macroLabel6.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue6.value="'+preferences.macroValue6.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel7.value="'+preferences.macroLabel7.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue7.value="'+preferences.macroValue7.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel8.value="'+preferences.macroLabel8.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue8.value="'+preferences.macroValue8.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel9.value="'+preferences.macroLabel9.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue9.value="'+preferences.macroValue9.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel10.value="'+preferences.macroLabel10.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue10.value="'+preferences.macroValue10.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel11.value="'+preferences.macroLabel11.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue11.value="'+preferences.macroValue11.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel12.value="'+preferences.macroLabel12.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue12.value="'+preferences.macroValue12.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel13.value="'+preferences.macroLabel13.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue13.value="'+preferences.macroValue13.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel14.value="'+preferences.macroLabel14.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue14.value="'+preferences.macroValue14.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel15.value="'+preferences.macroLabel15.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue15.value="'+preferences.macroValue15.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel16.value="'+preferences.macroLabel16.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue16.value="'+preferences.macroValue16.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel17.value="'+preferences.macroLabel17.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue17.value="'+preferences.macroValue17.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel18.value="'+preferences.macroLabel18.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue18.value="'+preferences.macroValue18.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel19.value="'+preferences.macroLabel19.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue19.value="'+preferences.macroValue19.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel20.value="'+preferences.macroLabel20.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue20.value="'+preferences.macroValue20.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel21.value="'+preferences.macroLabel21.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue21.value="'+preferences.macroValue21.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel22.value="'+preferences.macroLabel22.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue22.value="'+preferences.macroValue22.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel23.value="'+preferences.macroLabel23.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue23.value="'+preferences.macroValue23.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel24.value="'+preferences.macroLabel24.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue24.value="'+preferences.macroValue24.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel25.value="'+preferences.macroLabel25.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue25.value="'+preferences.macroValue25.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel26.value="'+preferences.macroLabel26.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue26.value="'+preferences.macroValue26.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel27.value="'+preferences.macroLabel27.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue27.value="'+preferences.macroValue27.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel28.value="'+preferences.macroLabel28.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue28.value="'+preferences.macroValue28.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel29.value="'+preferences.macroLabel29.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue29.value="'+preferences.macroValue29.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel30.value="'+preferences.macroLabel30.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue30.value="'+preferences.macroValue30.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel31.value="'+preferences.macroLabel31.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue31.value="'+preferences.macroValue31.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel32.value="'+preferences.macroLabel32.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue32.value="'+preferences.macroValue32.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel33.value="'+preferences.macroLabel33.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue33.value="'+preferences.macroValue33.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel34.value="'+preferences.macroLabel34.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue34.value="'+preferences.macroValue34.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel35.value="'+preferences.macroLabel35.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue35.value="'+preferences.macroValue35.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel36.value="'+preferences.macroLabel36.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue36.value="'+preferences.macroValue36.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel37.value="'+preferences.macroLabel37.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue37.value="'+preferences.macroValue37.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel38.value="'+preferences.macroLabel38.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue38.value="'+preferences.macroValue38.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel39.value="'+preferences.macroLabel39.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue39.value="'+preferences.macroValue39.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel40.value="'+preferences.macroLabel40.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue40.value="'+preferences.macroValue40.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel41.value="'+preferences.macroLabel41.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue41.value="'+preferences.macroValue41.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel42.value="'+preferences.macroLabel42.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue42.value="'+preferences.macroValue42.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel43.value="'+preferences.macroLabel43.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue43.value="'+preferences.macroValue43.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel44.value="'+preferences.macroLabel44.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue44.value="'+preferences.macroValue44.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel45.value="'+preferences.macroLabel45.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue45.value="'+preferences.macroValue45.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel46.value="'+preferences.macroLabel46.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue46.value="'+preferences.macroValue46.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel47.value="'+preferences.macroLabel47.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue47.value="'+preferences.macroValue47.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel48.value="'+preferences.macroLabel48.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue48.value="'+preferences.macroValue48.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel49.value="'+preferences.macroLabel49.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue49.value="'+preferences.macroValue49.value+'"; ';
		i++; preferenceString[i]='preferences.macroLabel50.value="'+preferences.macroLabel50.value+'"; ';
		i++; preferenceString[i]='preferences.macroValue50.value="'+preferences.macroValue50.value+'"; ';
		filesystem.writeFile(fileName,preferenceString);
}
